package com.FranckBarbier.Java._Parameter_passing;

public class Parameter_passing {

    public int i = 0; // To be avoided!

    public static void increment(int j) { // 'Integer j' is the same
        j++;
    }

    public static void f(Object o) {
        o = new Object();
    }

    public static void g(final Parameter_passing x) {
        x.i++;
    }

    public static void main(String[] args) {
        int j = 0;
        Parameter_passing.increment(j); // Copy of 'j'...
        System.out.println(j); // '0'

        Object o = new Object(), temp = o;
        Parameter_passing.f(o); // Copy of 'o'...
        assert (o == temp); // 

        Parameter_passing x = new Parameter_passing();
        assert (x.i == 0);
        Parameter_passing.g(x);
        assert (x.i == 1);
    }
}
